diff --git a/doc/guides/sample_app_ug/dist_app.rst b/doc/guides/sample_app_ug/dist_app.rst
index ec07b84..b073ce8 100644
--- a/doc/guides/sample_app_ug/dist_app.rst
+++ b/doc/guides/sample_app_ug/dist_app.rst
@@ -104,33 +104,34 @@ Running the Application
 Explanation
 -----------
 
-The distributor application consists of three types of threads: a receive
-thread (lcore_rx()), a set of worker threads(lcore_worker())
-and a transmit thread(lcore_tx()). How these threads work together is shown
-in :numref:`figure_dist_app` below. The main() function launches  threads of these three types.
-Each thread has a while loop which will be doing processing and which is
-terminated only upon SIGINT or ctrl+C. The receive and transmit threads
-communicate using a software ring (rte_ring structure).
-
-The receive thread receives the packets using rte_eth_rx_burst() and gives
-them to  the distributor (using rte_distributor_process() API) which will
-be called in context of the receive thread itself. The distributor distributes
-the packets to workers threads based on the tagging of the packet -
-indicated by the hash field in the mbuf. For IP traffic, this field is
-automatically filled by the NIC with the "usr" hash value for the packet,
-which works as a per-flow tag.
+The distributor application consists of four types of threads: a receive thread
+(lcore_rx()), a distributor thread (lcore_dist()), a set of worker threads
+(lcore_worker()), and a transmit thread(lcore_tx()). How these threads work
+together is shown in :numref:`figure_dist_app` below. The main() function
+launches  threads of these four types.  Each thread has a while loop which will
+be doing processing and which is terminated only upon SIGINT or ctrl+C.
+
+The receive thread receives the packets using rte_eth_rx_burst() and will
+enqueue them to an rte_ring. The distributor thread will dequeue the packets
+from the ring and assign them to workers (using rte_distributor_process() API).
+This assignment is based on the tag (or flow ID) of the packet - indicated by
+the hash field in the mbuf. For IP traffic, this field is automatically filled
+by the NIC with the "usr" hash value for the packet, which works as a per-flow
+tag.  The distributor thread communicates with the worker threads using a
+cache-line swapping mechanism, passing up to 8 mbuf pointers at a time
+(one cache line) to each worker.
 
 More than one worker thread can exist as part of the application, and these
 worker threads do simple packet processing by requesting packets from
 the distributor, doing a simple XOR operation on the input port mbuf field
 (to indicate the output port which will be used later for packet transmission)
-and then finally returning the packets back to the distributor in the RX thread.
+and then finally returning the packets back to the distributor thread.
 
-Meanwhile, the receive thread will call the distributor api
-rte_distributor_returned_pkts() to get the packets processed, and will enqueue
-them to a ring for transfer to the TX thread for transmission on the output port.
-The transmit thread will dequeue the packets from the ring and transmit them on
-the output port specified in packet mbuf.
+The distributor thread will then call the distributor api
+rte_distributor_returned_pkts() to get the processed packets, and will enqueue
+them to another rte_ring for transfer to the TX thread for transmission on the
+output port. The transmit thread will dequeue the packets from the ring and
+transmit them on the output port specified in packet mbuf.
 
 Users who wish to terminate the running of the application have to press ctrl+C
 (or send SIGINT to the app). Upon this signal, a signal handler provided
@@ -153,8 +154,10 @@ the line "#define DEBUG" defined in start of the application in main.c to enable
 Statistics
 ----------
 
-Upon SIGINT (or) ctrl+C, the print_stats() function displays the count of packets
-processed at the different stages in the application.
+The main function will print statistics on the console every second. These
+statistics include the number of packets enqueued and dequeued at each stage
+in the application, and also key statistics per worker, including how many
+packets of each burst size (1-8) were sent to each worker thread.
 
 Application Initialization
 --------------------------
diff --git a/doc/guides/sample_app_ug/img/dist_app.svg b/doc/guides/sample_app_ug/img/dist_app.svg
index 4714c7d..944f437 100644
--- a/doc/guides/sample_app_ug/img/dist_app.svg
+++ b/doc/guides/sample_app_ug/img/dist_app.svg
@@ -1,8 +1,7 @@
 <?xml version="1.0" encoding="UTF-8" standalone="no"?>
-
 <!--
 # BSD LICENSE
-# Copyright (c) <2014>, Intel Corporation
+# Copyright (c) <2014-2017>, Intel Corporation
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -47,8 +46,8 @@
    height="379.53668"
    id="svg4090"
    version="1.1"
-   inkscape:version="0.48.5 r10040"
-   sodipodi:docname="New document 2">
+   inkscape:version="0.92.1 r15371"
+   sodipodi:docname="dist_app.svg">
   <defs
      id="defs4092">
     <marker
@@ -200,8 +199,8 @@
      inkscape:pageopacity="0.0"
      inkscape:pageshadow="2"
      inkscape:zoom="1"
-     inkscape:cx="339.92174"
-     inkscape:cy="120.32038"
+     inkscape:cx="401.32873"
+     inkscape:cy="130.13572"
      inkscape:document-units="px"
      inkscape:current-layer="layer1"
      showgrid="false"
@@ -210,8 +209,8 @@
      fit-margin-right="0"
      fit-margin-bottom="0"
      inkscape:window-width="1920"
-     inkscape:window-height="1017"
-     inkscape:window-x="-8"
+     inkscape:window-height="1137"
+     inkscape:window-x="1912"
      inkscape:window-y="-8"
      inkscape:window-maximized="1" />
   <metadata
@@ -222,7 +221,7 @@
         <dc:format>image/svg+xml</dc:format>
         <dc:type
            rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-        <dc:title></dc:title>
+        <dc:title />
       </cc:Work>
     </rdf:RDF>
   </metadata>
@@ -232,40 +231,33 @@
      id="layer1"
      transform="translate(-35.078263,-28.308125)">
     <rect
-       style="fill:none;stroke:#000000;stroke-width:0.99999988;stroke-opacity:0.98412697"
+       style="fill:none;stroke:#000000;stroke-width:0.81890059;stroke-opacity:0.98412697"
        id="rect10443"
-       width="152.9641"
-       height="266.92566"
-       x="122.95611"
-       y="34.642567" />
-    <rect
-       style="fill:none;stroke:#000000;stroke-width:1;stroke-opacity:0.98412697"
-       id="rect10445"
-       width="124.71397"
-       height="46.675529"
-       x="435.7746"
-       y="28.808125" />
+       width="152.96732"
+       height="178.99617"
+       x="124.50176"
+       y="128.95552" />
     <rect
        style="fill:none;stroke:#000000;stroke-width:0.99999988;stroke-opacity:0.98412697"
        id="rect10445-2"
        width="124.71397"
        height="46.675529"
-       x="435.42999"
-       y="103.92654" />
+       x="437.00507"
+       y="133.06113" />
     <rect
        style="fill:none;stroke:#000000;stroke-width:0.99999988;stroke-opacity:0.98412697"
        id="rect10445-0"
        width="124.71397"
        height="46.675529"
        x="436.80811"
-       y="178.31572" />
+       y="193.87207" />
     <rect
        style="fill:none;stroke:#000000;stroke-width:0.99999988;stroke-opacity:0.98412697"
        id="rect10445-9"
        width="124.71397"
        height="46.675529"
        x="436.80811"
-       y="246.87038" />
+       y="256.06277" />
     <rect
        style="fill:none;stroke:#000000;stroke-width:0.99999988;stroke-opacity:0.98412697"
        id="rect10445-7"
@@ -274,203 +266,241 @@
        x="135.7057"
        y="360.66928" />
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Mstart)"
-       d="M 277.293,44.129101 433.02373,43.388655"
-       id="path10486"
-       inkscape:connector-type="polyline"
-       inkscape:connector-curvature="3" />
-    <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Mstart)"
-       d="m 277.83855,110.78109 155.73073,-0.74044"
+       style="fill:none;stroke:#000000;stroke-width:0.99566948;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:url(#Arrow1Mstart)"
+       d="M 278.89497,147.51907 436.5713,146.78234"
        id="path10486-2"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Mstart)"
-       d="m 278.48623,189.32721 155.73073,-0.74042"
+       style="fill:none;stroke:#000000;stroke-width:0.99290925;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:url(#Arrow1Mstart)"
+       d="m 279.37092,206.8834 156.80331,-0.73671"
        id="path10486-1"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Mstart)"
-       d="m 278.48623,255.19448 155.73073,-0.74043"
+       style="fill:none;stroke:#000000;stroke-width:0.99379504;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:url(#Arrow1Mstart)"
+       d="m 279.19738,270.88669 157.15478,-0.73638"
        id="path10486-4"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
-       d="M 277.11852,66.041829 432.84924,65.301384"
-       id="path10486-0"
-       inkscape:connector-type="polyline"
-       inkscape:connector-curvature="3" />
-    <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
-       d="M 277.46746,136.71727 433.1982,135.97682"
+       style="fill:none;stroke:#000000;stroke-width:0.99820405;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
+       d="m 277.17846,166.20347 158.11878,-0.73842"
        id="path10486-0-4"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
-       d="m 276.77843,210.37709 155.73073,-0.74044"
+       style="fill:none;stroke:#000000;stroke-width:0.99410033;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
+       d="m 277.47049,225.92925 157.32298,-0.73606"
        id="path10486-0-7"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.99200004;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
-       d="M 277.46746,282.5783 433.1982,281.83785"
+       style="fill:none;stroke:#000000;stroke-width:0.99566948;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
+       d="M 277.70474,289.26714 435.38107,288.5304"
        id="path10486-0-77"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
-       x="348.03241"
-       y="34.792767"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="345.02322"
+       y="134.82103"
        id="text11995"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
+       transform="scale(0.93992339,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997"
-         x="348.03241"
-         y="34.792767">Request packet</tspan></text>
+         x="345.02322"
+         y="134.82103"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">Request burst</tspan></text>
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
-       x="349.51935"
-       y="74.044792"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="346.38663"
+       y="164.76628"
        id="text11995-7"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
+       transform="scale(0.93992339,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3"
-         x="349.51935"
-         y="74.044792">Mbuf pointer</tspan></text>
+         x="346.38663"
+         y="164.76628"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">Mbuf Pointers</tspan></text>
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
-       x="504.26611"
-       y="52.165989"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="502.36844"
+       y="151.66222"
        id="text11995-7-3"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
+       transform="scale(0.93992339,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3-5"
-         x="504.26611"
-         y="52.165989">WorkerThread1</tspan></text>
+         x="502.36844"
+         y="151.66222"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">WorkerThread1</tspan></text>
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
-       x="501.65793"
-       y="121.54361"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="499.40103"
+       y="207.94502"
        id="text11995-7-3-9"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
+       transform="scale(0.93992339,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3-5-9"
-         x="501.65793"
-         y="121.54361">WorkerThread2</tspan></text>
+         x="499.40103"
+         y="207.94502"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">WorkerThread2</tspan></text>
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
-       x="499.45868"
-       y="191.46367"
-       id="text11995-7-3-8"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
-         sodipodi:role="line"
-         id="tspan11997-3-5-1"
-         x="499.45868"
-         y="191.46367">WorkerThread3</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
        x="500.1918"
-       y="257.9563"
+       y="266.59644"
        id="text11995-7-3-82"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
+       transform="scale(0.9399234,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3-5-6"
          x="500.1918"
-         y="257.9563">WorkerThreadN</tspan></text>
+         y="266.59644"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">WorkerThreadN</tspan></text>
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
        x="193.79703"
        y="362.85193"
        id="text11995-7-3-6"
-       sodipodi:linespacing="125%"
        transform="scale(0.93992342,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3-5-0"
          x="193.79703"
-         y="362.85193">TX thread</tspan></text>
+         y="362.85193"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">TX thread</tspan></text>
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
-       x="162.2476"
-       y="142.79382"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="175.78905"
+       y="207.26257"
        id="text11995-7-3-3"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
+       transform="scale(0.9399234,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3-5-8"
-         x="162.2476"
-         y="142.79382">RX thread &amp; Distributor</tspan></text>
+         x="175.78905"
+         y="207.26257"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">Distributor Thread</tspan></text>
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.75945646;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
-       d="m 35.457991,109.77995 85.546359,-0.79004"
+       style="fill:none;stroke:#000000;stroke-width:0.75945646;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
+       d="m 49.600127,54.625621 85.546363,-0.79004"
        id="path10486-0-4-5"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <path
-       style="fill:none;stroke:#000000;stroke-width:0.75945646;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-opacity:1;stroke-dasharray:none;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
+       style="fill:none;stroke:#000000;stroke-width:0.75945646;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:1;marker-start:none;marker-mid:none;marker-end:url(#Arrow1Mend)"
        d="m 135.70569,384.00706 -85.546361,0.79003"
        id="path10486-0-4-5-7"
        inkscape:connector-type="polyline"
        inkscape:connector-curvature="3" />
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
-       x="58.296661"
-       y="96.037407"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="73.342712"
+       y="44.196564"
        id="text11995-7-8"
-       sodipodi:linespacing="125%"
-       transform="scale(0.93992342,1.0639165)"><tspan
+       transform="scale(0.9399234,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3-3"
-         x="58.296661"
-         y="96.037407">Mbufs In</tspan></text>
+         x="73.342712"
+         y="44.196564"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">Mbufs In</tspan></text>
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
        x="83.4814"
        y="352.62543"
        id="text11995-7-8-5"
-       sodipodi:linespacing="125%"
        transform="scale(0.93992342,1.0639165)"><tspan
          sodipodi:role="line"
          id="tspan11997-3-3-1"
          x="83.4814"
-         y="352.62543">Mbufs Out</tspan></text>
+         y="352.62543"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">Mbufs Out</tspan></text>
     <path
-       style="fill:none;stroke:#000000;stroke-width:1.05720723;stroke-miterlimit:3;stroke-opacity:0.98412697;stroke-dasharray:none"
-       d="m 171.68192,303.16236 0.21464,30.4719 -8.6322,0.40574 -11.33877,0.1956 25.75778,14.79103 23.25799,11.11792 18.87014,-7.32926 31.83305,-17.26495 -10.75831,-0.32986 -10.37586,-0.44324 -0.22443,-31.54093 z"
+       style="fill:none;stroke:#000000;stroke-width:1.01068497;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:0.98412697"
+       d="m 171.68192,308.06701 0.21464,27.84908 -8.6322,0.37082 -11.33877,0.17876 25.75778,13.51792 23.25799,10.16096 18.87014,-6.69841 31.83305,-15.77889 -10.75831,-0.30147 -10.37586,-0.40509 -0.22443,-28.8261 z"
        id="path12188"
        inkscape:connector-curvature="0"
-       inkscape:transform-center-y="7.6863474"
+       inkscape:transform-center-y="7.0247597"
        sodipodi:nodetypes="cccccccccccc" />
     <text
        xml:space="preserve"
-       style="font-size:9.32312489px;font-style:normal;font-weight:normal;line-height:125%;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
        x="193.68871"
        y="309.26349"
        id="text11995-7-3-6-2"
-       sodipodi:linespacing="125%"
        transform="scale(0.93992342,1.0639165)"><tspan
          sodipodi:role="line"
          x="193.68871"
          y="309.26349"
-         id="tspan12214">SW Ring</tspan></text>
+         id="tspan12214"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">SW Ring</tspan></text>
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1.02106845;stroke-miterlimit:3;stroke-dasharray:none;stroke-opacity:0.98412697"
+       d="m 173.27214,75.568236 0.21464,28.424254 -8.6322,0.37848 -11.33877,0.18245 25.75778,13.79709 23.25799,10.37083 18.87013,-6.83675 31.83305,-16.10478 -10.75831,-0.30769 -10.37586,-0.41345 -0.22443,-29.421453 z"
+       id="path12188-5"
+       inkscape:connector-curvature="0"
+       inkscape:transform-center-y="7.1698404"
+       sodipodi:nodetypes="cccccccccccc" />
+    <rect
+       style="fill:none;stroke:#000000;stroke-width:0.99999988;stroke-opacity:0.98412697"
+       id="rect10445-7-7"
+       width="124.71397"
+       height="46.675529"
+       x="138.18427"
+       y="28.832333" />
+    <text
+       xml:space="preserve"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="190.80019"
+       y="51.17778"
+       id="text11995-7-3-6-6"
+       transform="scale(0.93992339,1.0639165)"><tspan
+         sodipodi:role="line"
+         id="tspan11997-3-5-0-4"
+         x="190.80019"
+         y="51.17778"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">RX thread</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="196.38097"
+       y="90.224785"
+       id="text11995-7-3-6-2-9"
+       transform="scale(0.93992339,1.0639165)"><tspan
+         sodipodi:role="line"
+         x="196.38097"
+         y="90.224785"
+         id="tspan12214-8"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">SW Ring</tspan></text>
+    <rect
+       style="fill:none;stroke:#000000;stroke-width:0.99999988;stroke-opacity:0.98412697"
+       id="rect10445-7-7-5"
+       width="124.71397"
+       height="46.675529"
+       x="327.86566"
+       y="29.009106" />
+    <text
+       xml:space="preserve"
+       style="font-style:normal;font-weight:normal;line-height:0%;font-family:sans-serif;letter-spacing:0px;word-spacing:0px;fill:#000000;fill-opacity:1;stroke:none"
+       x="387.27209"
+       y="45.36227"
+       id="text11995-7-3-6-6-3"
+       transform="scale(0.93992339,1.0639165)"><tspan
+         sodipodi:role="line"
+         id="tspan11997-3-5-0-4-4"
+         x="387.27209"
+         y="45.36227"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif">Stats thread</tspan><tspan
+         sodipodi:role="line"
+         x="387.27209"
+         y="57.016178"
+         style="font-size:9.32312489px;line-height:1.25;font-family:sans-serif"
+         id="tspan165">(to console)</tspan></text>
   </g>
 </svg>